Sponsored Content
Top Forums Shell Programming and Scripting cmd || echo "something" - doesn't exit uppon error Post 302579091 by radoulov on Sunday 4th of December 2011 02:37:54 PM
Old 12-04-2011
This should do what you want:

Code:
for i in ad0 ad1; do

  gpart create -s gpt "$i" || {
    printf >&2 'Cannot create GPT partition on "%s". Exiting ...\n' "$i"
    exit 1
    }
  
  gpart add -s 128 -t freebsd-boot "$i" || {
    printf >&2 'Cannot add freebsd-boot partition on "%s". Exiting ...\n' "$i"
    exit 1
    }
    
  gpart add -s 4G -t freebsd-swap -l swap "$i" || {
    printf >&2 'Cannot add freebsd-swap partition to "%s". Exiting ...\n'
    exit 1
    }
    
  gpart bootcode -b /mnt2/boot/pmbr -p /mnt2/boot/gptzfsboot -i 1 "$i" || {
    printf >&2 'Cannot add bootcode to "%s". Exiting ...\n' "$i"
    exit 1
    }
    
done

Something like this would be even better:

Code:
die() {
  [ -n "$1" ] &&
    printf >&2 '%s\n' "$1"
  exit 1
  }

for i in ad0 ad1; do

  gpart create -s gpt "$i" || 
    die "Cannot create GPT partition on $i. Exiting ..." 
  
  gpart add -s 128 -t freebsd-boot "$i" || 
    die "Cannot add freebsd-boot partition on $i. Exiting ..."
    
  gpart add -s 4G -t freebsd-swap -l swap "$i" || 
    die "Cannot add freebsd-swap partition to $i. Exiting ..."

  gpart bootcode -b /mnt2/boot/pmbr -p /mnt2/boot/gptzfsboot -i 1 "$i" || 
    die "Cannot add bootcode to "%s". Exiting ..."
    
done

You may need to hide the errors in a logfile, given that you want to handle the exceptions:

Code:
_errlog=${0##*/}_error.log

die() {
  [ -n "$1" ] &&
    printf >&2 '%s\n' "$1"
  exit 1
  }

for i in ad0 ad1; do

  gpart create -s gpt "$i" 2> "$_errlog" || 
    die "Cannot create GPT partition on $i. Exiting ..." 
  
  gpart add -s 128 -t freebsd-boot "$i" 2> "$_errlog" || 
    die "Cannot add freebsd-boot partition on $i. Exiting ..."
    
  gpart add -s 4G -t freebsd-swap -l swap "$i" 2> "$_errlog" || 
    die "Cannot add freebsd-swap partition to $i. Exiting ..."

  gpart bootcode -b /mnt2/boot/pmbr -p /mnt2/boot/gptzfsboot -i 1 "$i" 2> "$_errlog" || 
    die "Cannot add bootcode to "%s". Exiting ..."
    
done


Last edited by radoulov; 12-04-2011 at 03:46 PM..
 

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

assign shell var output of cmd "wc"

how do I feed output of "wc" to a shell script variable "countBcp"? (2 Replies)
Discussion started by: devy
2 Replies

2. Shell Programming and Scripting

Need help on use of "cmd" command in net::Telnet module in PERL

in "cmd" command i want to copy the ouput of the command excuted to a particular file in a directory. How to do this..?? Ex : $telnet->cmd(String => 'allip:acl=a1;',Prompt => '/</'); i want to copy o/p of the command "allip:acl=a1;" in a log file in a particular directory. Plz suggest.. (1 Reply)
Discussion started by: sudhakaryadav
1 Replies

3. Shell Programming and Scripting

"sed" to check file size & echo " " to destination file

Hi, I've modified the syslogd source to include a thread that will keep track of a timer(or a timer thread). My intention is to check the file size of /var/log/messages in every one minute & if the size is more than 128KB, do a echo " " > /var/log/messages, so that the file size will be set... (7 Replies)
Discussion started by: jockey007
7 Replies

4. Shell Programming and Scripting

Difference between using "echo" builtin and /bin/echo

So in my shell i execute: { while true; do echo string; sleep 1; done } | read line This waits one second and returns. But { while true; do /bin/echo string; sleep 1; done } | read line continues to run, and doesn't stop until i kill it explicitly. I have tried this in bash as well as zsh,... (2 Replies)
Discussion started by: ulidtko
2 Replies

5. Shell Programming and Scripting

With that logic this echoes "echo". Question about echo!

echo `echo ` doesn't echoes anything. And it's logic. But echo `echo `echo ` ` does echoes "echo". What's the logic of it? the `echo `echo ` inside of the whole (first) echo, echoes nothing, so the first echo have to echo nothing but echoes "echo" (too much echoing :P):o (2 Replies)
Discussion started by: hakermania
2 Replies

6. Shell Programming and Scripting

awk command to replace ";" with "|" and ""|" at diferent places in line of file

Hi, I have line in input file as below: 3G_CENTRAL;INDONESIA_(M)_TELKOMSEL;SPECIAL_WORLD_GRP_7_FA_2_TELKOMSEL My expected output for line in the file must be : "1-Radon1-cMOC_deg"|"LDIndex"|"3G_CENTRAL|INDONESIA_(M)_TELKOMSEL"|LAST|"SPECIAL_WORLD_GRP_7_FA_2_TELKOMSEL" Can someone... (7 Replies)
Discussion started by: shis100
7 Replies

7. Shell Programming and Scripting

Perl open(CMD, "cmd |"); buffering problem..

Hello, There's a third-party application's command that shows the application's status like "tail -f verybusy.log". When use the command, the output comes every 1-sec. but when it goes in a script below the output comes every 8-sec...What is the problem and how can I fix it? open(CMD,... (2 Replies)
Discussion started by: Shawn, Lee
2 Replies

8. AIX

echo $varibla | mail -s "subject" "xxx@xxx.com" not ruuning as expected

Hi Folks, As per the subject, the following command is not working as expected. echo $variable | mail -s "subject" "xxx@xxx.com" Could anyone figure it out whats wrong with this. I am using AIX box. Regards, (2 Replies)
Discussion started by: gjarms
2 Replies

9. Shell Programming and Scripting

tcsh - understanding difference between "echo string" and "echo string > /dev/stdout"

I came across and unexpected behavior with redirections in tcsh. I know, csh is not best for redirections, but I'd like to understand what is happening here. I have following script (called out_to_streams.csh): #!/bin/tcsh -f echo Redirected to STDOUT > /dev/stdout echo Redirected to... (2 Replies)
Discussion started by: marcink
2 Replies

10. Shell Programming and Scripting

Bash script - Print an ascii file using specific font "Latin Modern Mono 12" "regular" "9"

Hello. System : opensuse leap 42.3 I have a bash script that build a text file. I would like the last command doing : print_cmd -o page-left=43 -o page-right=22 -o page-top=28 -o page-bottom=43 -o font=LatinModernMono12:regular:9 some_file.txt where : print_cmd ::= some printing... (1 Reply)
Discussion started by: jcdole
1 Replies
SYSTEMD-GPT-AUTO-GENERATOR(8)                               systemd-gpt-auto-generator                               SYSTEMD-GPT-AUTO-GENERATOR(8)

NAME
systemd-gpt-auto-generator - Generator for automatically discovering and mounting root, /home and /srv partitions, as well as discovering and enabling swap partitions, based on GPT partition type GUIDs. SYNOPSIS
/lib/systemd/system-generators/systemd-gpt-auto-generator DESCRIPTION
systemd-gpt-auto-generator is a unit generator that automatically discovers root, /home, /srv and swap partitions and creates mount and swap units for them, based on the partition type GUIDs of GUID partition tables (GPT). It implements the Discoverable Partitions Specification[1]. Note that this generator has no effect on non-GPT systems, or where the directories under the mount points are already non-empty. Also, on systems where the units are explicitly configured (for example, listed in fstab(5)), the units this generator creates are overridden, but additional implicit dependencies might be created. This generator will only look for root partitions on the same physical disk the EFI System Partition (ESP) is located on. It will only look for the other partitions on the same physical disk the root file system is located on. These partitions will not be searched on systems where the root file system is distributed on multiple disks, for example via btrfs RAID. systemd-gpt-auto-generator is useful for centralizing file system configuration in the partition table and making manual configuration in /etc/fstab or suchlike unnecessary. This generator looks for the partitions based on their partition type GUID. The following partition type GUIDs are identified: Table 1. Partition Type GUIDs +-------------------------------------+--------------------------------+--------------------------------------+ |Partition Type GUID | Name | Explanation | +-------------------------------------+--------------------------------+--------------------------------------+ |44479540-f297-41b2-9af7-d131d5f0458a | Root Partition (x86) | On 32-bit x86 systems, the first x86 | | | | root partition on the disk the EFI | | | | ESP is located on is mounted to the | | | | root directory /. | +-------------------------------------+--------------------------------+--------------------------------------+ |4f68bce3-e8cd-4db1-96e7-fbcaf984b709 | Root Partition (x86-64) | On 64-bit x86 systems, the first | | | | x86-64 root partition on the disk | | | | the EFI ESP is located on is mounted | | | | to the root directory /. | +-------------------------------------+--------------------------------+--------------------------------------+ |69dad710-2ce4-4e3c-b16c-21a1d49abed3 | Root Partition (32-bit ARM) | On 32-bit ARM systems, the first ARM | | | | root partition on the disk the EFI | | | | ESP is located on is mounted to the | | | | root directory /. | +-------------------------------------+--------------------------------+--------------------------------------+ |b921b045-1df0-41c3-af44-4c6f280d3fae | Root Partition (64-bit ARM) | On 64-bit ARM systems, the first ARM | | | | root partition on the disk the EFI | | | | ESP is located on is mounted to the | | | | root directory /. | +-------------------------------------+--------------------------------+--------------------------------------+ |993d8d3d-f80e-4225-855a-9daf8ed7ea97 | Root Partition (Itanium/IA-64) | On Itanium systems, the first | | | | Itanium root partition on the disk | | | | the EFI ESP is located on is mounted | | | | to the root directory /. | +-------------------------------------+--------------------------------+--------------------------------------+ |933ac7e1-2eb4-4f13-b844-0e14e2aef915 | Home Partition | The first home partition on the disk | | | | the root partition is located on is | | | | mounted to /home. | +-------------------------------------+--------------------------------+--------------------------------------+ |3b8f8425-20e0-4f3b-907f-1a25a76f98e8 | Server Data Partition | The first server data partition on | | | | the disk the root partition is | | | | located on is mounted to /srv. | +-------------------------------------+--------------------------------+--------------------------------------+ |0657fd6d-a4ab-43c4-84e5-0933c84b4f4f | Swap | All swap partitions located on the | | | | disk the root partition is located | | | | on are enabled. | +-------------------------------------+--------------------------------+--------------------------------------+ |c12a7328-f81f-11d2-ba4b-00a0c93ec93b | EFI System Partition (ESP) | The first ESP located on the disk | | | | the root partition is located on is | | | | mounted to /boot or /efi, see below. | +-------------------------------------+--------------------------------+--------------------------------------+ The /home and /srv partitions may be encrypted in LUKS format. In this case, a device mapper device is set up under the names /dev/mapper/home and /dev/mapper/srv. Note that this might create conflicts if the same partition is listed in /etc/crypttab with a different device mapper device name. Mount and automount units for the EFI System Partition (ESP) are generated on EFI systems. The ESP is mounted to /boot, unless a mount point directory /efi exists, in which case it is mounted there. Since this generator creates an automount unit, the mount will only be activated on-demand, when accessed. On systems where /boot (or /efi if it exists) is an explicitly configured mount (for example, listed in fstab(5)) or where the /boot (or /efi) mount point is non-empty, no mount units are generated. When using this generator in conjunction with btrfs file systems, make sure to set the correct default subvolumes on them, using btrfs subvolume set-default. systemd-gpt-auto-generator implements systemd.generator(7). SEE ALSO
systemd(1), systemd.mount(5), systemd.swap(5), systemd-fstab-generator(8), systemd-cryptsetup@.service(8), cryptsetup(8), fstab(5), btrfs(8) NOTES
1. Discoverable Partitions Specification https://www.freedesktop.org/wiki/Specifications/DiscoverablePartitionsSpec/ systemd 237 SYSTEMD-GPT-AUTO-GENERATOR(8)
All times are GMT -4. The time now is 01:42 PM.
Unix & Linux Forums Content Copyright 1993-2022. All Rights Reserved.
Privacy Policy